//AnnulerObjetsAncres_501f.js
// 30.05.14 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Liberer des objets ancrs

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// vrifier s'il y a un document ouvert
if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}

// le document au premier plan
curDoc = app.documents[0];

// mmoriser la slection
curSel = app.selection;

// quand il n'y a pas de slection, le document entier est trat
if (curSel.length == 0) {
	// toutes les chanes de texte
	var allStories = curDoc.stories;
	// une boucle  travers  les chanes de texte
	for (var s=0; s<allStories.length; s++) {
		// la chane de texte actuelle
		var curStory = allStories[s];
		// appeler la fonction "rechercher"
		findAnchored(curStory);
	}
}
else {
	for (var s=0; s<curSel.length; s++) {
		if (curSel[s].parent.constructor.name == "Character") {
			releaseObj(curSel[s]);
		}
		else {
			if (curSel[s].hasOwnProperty("baseline") == true) {
				// la chane de texte actuelle
				var curStory = curSel[s].parent;
				// appeler la fonction "rechercher"
				findAnchored(curStory);
			}
			else if (curSel[s].constructor.name == "TextFrame") {
				// la chane de texte actuelle
				var curStory = curSel[s].parentStory;
				// appeler la fonction "rechercher"
				findAnchored(curStory);
			}
		}
	}
}

// annuler la dernire slection
app.selection = null;

// annoncer la fin de l'action
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Termin.");
dlog.show();
// une petite pause
$.sleep(999);
// fermer la fentre
dlog.close();

// la fonction qui trouve les ancrages
function findAnchored(curStory) {
	// le sobjets ancrs
	var allObj = curStory.allPageItems;
	// une boucle  travers les objets
	for (var n=allObj.length-1; n>-1; n--) {
		var curObj = allObj[n];
		if (curObj.parent.constructor.name == "Character") {
			// appeler la fonction qui libre l'objet
			releaseObj(curObj);
		}
	}
}

// fonction qui libre les objets
function releaseObj(curObj) {
	try {
		// dverrouiller
		curObj.locked = false;
		curObj.select(SelectionOptions.replaceWith);
		var gB = curObj.geometricBounds;
		app.activeWindow.zoomPercentage = 100;
		app.cut();
		app.paste();
		app.selection[0].move([gB[1], gB[0]]);
	}
	catch (e) {
	}
}